* configure.in (mn10300): Build everything except gdb & libgloss.
[deliverable/binutils-gdb.git] / configure.in
1 #! /bin/bash
2 ##############################################################################
3
4 ## This file is a shell script fragment that supplies the information
5 ## necessary to tailor a template configure script into the configure
6 ## script appropriate for this directory. For more information, check
7 ## any existing configure script.
8
9 ## Be warned, there are two types of configure.in files. There are those
10 ## used by Autoconf, which are macros which are expanded into a configure
11 ## script by autoconf. The other sort, of which this is one, is executed
12 ## by Cygnus configure.
13
14 ## For more information on these two systems, check out the documentation
15 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
16
17 # Copyright (C) 1992, 93, 94, 95, 1996 Free Software Foundation, Inc.
18 #
19 # This file is free software; you can redistribute it and/or modify it
20 # under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23 #
24 # This program is distributed in the hope that it will be useful, but
25 # WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
27 # General Public License for more details.
28 #
29 # You should have received a copy of the GNU General Public License
30 # along with this program; if not, write to the Free Software
31 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
32
33 ##############################################################################
34
35 ### To add a new directory to the tree, first choose whether it is a target
36 ### or a host dependent tool. Then put it into the appropriate list
37 ### (library or tools, host or target), doing a dependency sort. For
38 ### example, gdb requires that byacc (or bison) be built first, so it is in
39 ### the ${host_tools} list after byacc and bison.
40
41
42 # these libraries are used by various programs built for the host environment
43 #
44 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
45
46 if [ "${enable_gdbgui}" = "yes" ] ; then
47 host_libs="${host_libs} libgui"
48 fi
49
50 # these tools are built for the host environment
51 #
52 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch prms send-pr gprof gdbtest tgas etc expect dejagnu sim bash m4 autoconf ispell grep diff rcs cvs fileutils shellutils time textutils wdiff find emacs emacs19 uudecode hello tar gzip indent recode release sed utils guile perl apache inet gawk"
53
54
55 # these libraries are built for the target environment, and are built after
56 # the host libraries and the host tools (which may be a cross compiler)
57 #
58 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
59
60
61 # these tools are built using the target libs, and are intended to run only
62 # in the target environment
63 #
64 # note: any program that *uses* libraries that are in the "target_libs"
65 # list belongs in this list. those programs are also very likely
66 # candidates for the "native_only" list which follows
67 #
68 target_tools="target-examples target-groff"
69
70 ################################################################################
71
72 ## These two lists are of directories that are to be removed from the
73 ## ${configdirs} list for either cross-compilations or for native-
74 ## compilations. For example, it doesn't make that much sense to
75 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
76 ## a native environment.
77
78 # directories to be built in the native environment only
79 #
80 # This must be a single line because of the way it is searched by grep in
81 # the code below.
82 native_only="autoconf cvs emacs emacs19 fileutils find gawk grep gzip hello indent ispell m4 rcs recode sed shellutils tar textutils gash uudecode wdiff gprof target-groff guile perl apache inet time bash prms"
83
84 # directories to be built in a cross environment only
85 #
86 cross_only="target-libiberty target-libgloss target-newlib"
87
88 ## All tools belong in one of the four categories, and are assigned above
89 ## We assign ${configdirs} this way to remove all embedded newlines. This
90 ## is important because configure will choke if they ever get through.
91 ## ${configdirs} is directories we build using the host tools.
92 ## ${target_configdirs} is directories we build using the target tools.
93 #
94 configdirs=`echo ${host_libs} ${host_tools}`
95 target_configdirs=`echo ${target_libs} ${target_tools}`
96
97 ################################################################################
98
99 srctrigger=move-if-change
100 srcname="gnu development package"
101
102 # This gets set non-empty for some net releases of packages.
103 appdirs=""
104
105 # per-host:
106
107 # Work in distributions that contain no compiler tools, like Autoconf.
108 if [ -d ${srcdir}/config ]; then
109 case "${host}" in
110 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
111 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
112 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
113 m68k-*-linux*) host_makefile_frag=config/mh-linux ;;
114 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
115 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
116 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
117 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
118 mips*-nec-sysv4*) host_makefile_frag=config/mh-necv4 ;;
119 mips*-sgi-irix6*) host_makefile_frag=config/mh-irix6 ;;
120 mips*-sgi-irix5*) host_makefile_frag=config/mh-irix5 ;;
121 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
122 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
123 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
124 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
125 i[3456]86-*-dgux*) host_makefile_frag=config/mh-dgux386 ;;
126 i[3456]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
127 i[3456]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
128 i[3456]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
129 i[3456]86-*-sco*) host_makefile_frag=config/mh-sco ;;
130 i[3456]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
131 i[3456]86-*-linux*) host_makefile_frag=config/mh-linux ;;
132 i[3456]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
133 i[3456]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
134 i[3456]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
135 *-cygwin32*) host_makefile_frag=config/mh-cygwin32 ;;
136 *-windows*) host_makefile_frag=config/mh-windows ;;
137 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
138 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
139 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
140 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
141 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
142 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
143 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
144 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
145 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
146 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
147 esac
148 fi
149
150 # If we aren't going to be using gcc, see if we can extract a definition
151 # of CC from the fragment.
152 if [ -z "${CC}" -a "${build}" = "${host}" ]; then
153 IFS="${IFS= }"; save_ifs="$IFS"; IFS="${IFS}:"
154 found=
155 for dir in $PATH; do
156 test -z "$dir" && dir=.
157 if test -f $dir/gcc; then
158 found=yes
159 break
160 fi
161 done
162 IFS="$save_ifs"
163 if [ -z "${found}" -a -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
164 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
165 if [ -n "${xx}" ] ; then
166 CC=$xx
167 fi
168 fi
169 fi
170
171 # We default to --with-shared on platforms where -fpic is meaningless.
172 # Well, we don't yet, but we will.
173 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
174 case "${target}" in
175 alpha-dec-osf*) enable_shared=yes ;;
176 alpha-*-linux*) enable_shared=yes ;;
177 mips-sgi-irix5*) enable_shared=yes ;;
178 *) enable_shared=no ;;
179 esac
180 fi
181
182 case "${enable_shared}" in
183 yes) shared=yes ;;
184 no) shared=no ;;
185 "") shared=no ;;
186 *) shared=yes ;;
187 esac
188
189 if [ x${shared} = xyes ]; then
190 waugh=
191 case "${host}" in
192 hppa*) waugh=config/mh-papic ;;
193 i[3456]86-*) waugh=config/mh-x86pic ;;
194 sparc64-*) waugh=config/mh-sparcpic ;;
195 *) waugh=config/mh-${host_cpu}pic ;;
196 esac
197 if [ -f ${srcdir}/${waugh} ]; then
198 if [ -n "${host_makefile_frag}" ] ; then
199 cat ${srcdir}/${host_makefile_frag} > mh-frag
200 cat ${srcdir}/${waugh} >> mh-frag
201 host_makefile_frag=mh-frag
202 else
203 host_makefile_frag=${waugh}
204 fi
205 fi
206 fi
207
208 # per-target:
209
210 case "${target}" in
211 v810*) target_makefile_frag=config/mt-v810 ;;
212 i[3456]86-*-netware*) target_makefile_frag=config/mt-netware ;;
213 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
214 esac
215
216 skipdirs=
217 gasdir=gas
218 use_gnu_ld=
219 use_gnu_as=
220
221 # some tools are so dependent upon X11 that if we're not building with X,
222 # it's not even worth trying to configure, much less build, that tool.
223
224 case ${with_x} in
225 yes | "") # the default value for this tree is that X11 is available
226 ;;
227 no)
228 skipdirs="${skipdirs} tk gash"
229 ;;
230 *)
231 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
232 ;;
233 esac
234
235 # Some tools are only suitable for building in a "native" situation.
236 # Those are added when we have a host==target configuration. For cross
237 # toolchains, we add some directories that should only be useful in a
238 # cross-compiler.
239
240 is_cross_compiler=
241
242 if [ x"${host}" = x"${target}" ] ; then
243 # when doing a native toolchain, don't build the targets
244 # that are in the 'cross only' list
245 skipdirs="${skipdirs} ${cross_only}"
246 is_cross_compiler=no
247 target_subdir=.
248 else
249 # similarly, don't build the targets in the 'native only'
250 # list when building a cross compiler
251 skipdirs="${skipdirs} ${native_only}"
252 is_cross_compiler=yes
253 target_subdir=${target_alias}
254 if [ ! -d ${target_subdir} ] ; then
255 if mkdir ${target_subdir} ; then true
256 else
257 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
258 exit 1
259 fi
260 fi
261 fi
262
263 copy_dirs=
264
265 # Handle --with-headers=XXX. The contents of the named directory are
266 # copied to $(tooldir)/sys-include.
267 if [ x"${with_headers}" != x ]; then
268 if [ x${is_cross_compiler} = xno ]; then
269 echo 1>&2 '***' --with-headers is only supported when cross compiling
270 exit 1
271 fi
272 case "${exec_prefixoption}" in
273 "") x=${prefix} ;;
274 *) x=${exec_prefix} ;;
275 esac
276 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
277 fi
278
279 # Handle --with-libs=XXX. Multiple directories are permitted. The
280 # contents are copied to $(tooldir)/lib.
281 if [ x"${with_libs}" != x ]; then
282 if [ x${is_cross_compiler} = xno ]; then
283 echo 1>&2 '***' --with-libs is only supported when cross compiling
284 exit 1
285 fi
286 # Copy the libraries in reverse order, so that files in the first named
287 # library override files in subsequent libraries.
288 case "${exec_prefixoption}" in
289 "") x=${prefix} ;;
290 *) x=${exec_prefix} ;;
291 esac
292 for l in ${with_libs}; do
293 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
294 done
295 fi
296
297 # If both --with-headers and --with-libs are specified, default to
298 # --without-newlib.
299 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
300 if [ x"${with_newlib}" = x ]; then
301 with_newlib=no
302 fi
303 fi
304
305 # Recognize --with-newlib/--without-newlib.
306 if [ x${with_newlib} = xno ]; then
307 skipdirs="${skipdirs} target-newlib"
308 elif [ x${with_newlib} = xyes ]; then
309 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
310 fi
311
312 # Default to using --with-stabs for certain targets.
313 if [ x${with_stabs} = x ]; then
314 case "${target}" in
315 mips*-*-* | alpha*-*-osf* | i[3456]86*-*-sysv4* | i[3456]86*-*-unixware*)
316 with_stabs=yes;
317 withoptions="${withoptions} --with-stabs"
318 ;;
319 esac
320 fi
321
322 # Handle ${copy_dirs}
323 set fnord ${copy_dirs}
324 shift
325 while [ $# != 0 ]; do
326 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
327 :
328 else
329 echo Copying $1 to $2
330
331 # Use the install script to create the directory and all required
332 # parent directories.
333 if [ -d $2 ]; then
334 :
335 else
336 echo >config.temp
337 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
338 fi
339
340 # Copy the directory, assuming we have tar.
341 # FIXME: Should we use B in the second tar? Not all systems support it.
342 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
343
344 # It is the responsibility of the user to correctly adjust all
345 # symlinks. If somebody can figure out how to handle them correctly
346 # here, feel free to add the code.
347
348 echo $1 > $2/COPIED
349 fi
350 shift; shift
351 done
352
353 # Configure extra directories which are host specific
354
355 case "${host}" in
356 i[3456]86-*-go32*)
357 configdirs="$configdirs dosrel" ;;
358 *-cygwin32*)
359 configdirs="$configdirs dosrel" ;;
360 esac
361
362 # Remove more programs from consideration, based on the host or
363 # target this usually means that a port of the program doesn't
364 # exist yet.
365
366 noconfigdirs=""
367
368 case "${host}" in
369 i[3456]86-*-vsta)
370 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
371 ;;
372 i[3456]86-*-go32)
373 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff guile perl apache inet"
374 ;;
375 *-*-cygwin32)
376 noconfigdirs="tk tcl expect dejagnu cvs autoconf bison send-pr gprof rcs guile perl texinfo apache inet"
377 ;;
378 *-*-windows*)
379 # This is only used to build WinGDB...
380 configdirs="bfd gdb libiberty opcodes readline sim"
381 target_configdirs=
382 ;;
383 ppc*-*-pe)
384 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs guile perl apache inet"
385 ;;
386 esac
387
388
389 case "${target}" in
390 *-*-netware)
391 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty target-libgloss"
392 ;;
393 *-*-vxworks*)
394 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
395 ;;
396 alpha-dec-osf*)
397 # ld works, but does not support shared libraries. emacs doesn't
398 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
399 # gas doesn't generate exception information.
400 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib target-libgloss"
401 ;;
402 alpha*-*-*vms*)
403 noconfigdirs="$noconfigdirs gdb ld target-newlib target-libgloss"
404 ;;
405 alpha*-*-*)
406 # newlib is not 64 bit ready
407 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
408 ;;
409 # start-sanitize-arc
410 arc-*-*)
411 noconfigdirs="$noconfigdirs target-libgloss"
412 ;;
413 # end-sanitize-arc
414 arm-*-pe*)
415 noconfigdirs="$noconfigdirs target-libgloss"
416 ;;
417 arm-*-coff*)
418 noconfigdirs="$noconfigdirs target-libgloss"
419 ;;
420 arm-*-riscix*)
421 noconfigdirs="$noconfigdirs ld target-libgloss"
422 ;;
423 # start-sanitize-d10v
424 d10v-*-*)
425 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-libgloss"
426 ;;
427 # end-sanitize-d10v
428 h8300*-*-* | \
429 h8500-*-*)
430 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
431 ;;
432 hppa*-*-*elf* | \
433 hppa*-*-lites*)
434 # Do configure ld/binutils/gas for this case.
435 ;;
436 hppa*-*-*)
437 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
438 # cc is gcc, and on any system a user should be able to link cc to
439 # whatever they want. FIXME, emacs emacs19).
440 case "${CC}" in
441 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
442 *) ;;
443 esac
444 noconfigdirs="$noconfigdirs ld shellutils"
445 ;;
446 i[3456]86-*-go32)
447 # but don't build gdb
448 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
449 ;;
450 *-*-cygwin32)
451 target_configdirs="$target_configdirs target-winsup"
452 noconfigdirs="$noconfigdirs tcl tk expect target-libgloss"
453 # always build newlib.
454 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
455
456 # Can't build gdb for cygwin32 if not native.
457 case "${host}" in
458 *-*-cygwin32) ;; # keep gdb
459 *) noconfigdirs="$noconfigdirs gdb"
460 esac
461 ;;
462 i[3456]86-*-pe)
463 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx target-libgloss"
464 ;;
465 i[3456]86-*-sco3.2v5*)
466 # The linker does not yet know about weak symbols in COFF,
467 # and is not configured to handle mixed ELF and COFF.
468 noconfigdirs="$noconfigdirs gprof ld target-libgloss"
469 ;;
470 i[3456]86-*-sco*)
471 noconfigdirs="$noconfigdirs gprof target-libgloss"
472 ;;
473 i[3456]86-*-solaris2*)
474 # The linker does static linking correctly, but the Solaris C library
475 # has bugs such that some important functions won't work when statically
476 # linked. (See man pages for getpwuid, for example.)
477 noconfigdirs="$noconfigdirs ld target-libgloss"
478 ;;
479 i[3456]86-*-sysv4*)
480 # The SYSV4 C compiler doesn't handle Emacs correctly
481 case "${CC}" in
482 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
483 *) ;;
484 esac
485 # but that's okay since emacs doesn't work anyway
486 noconfigdirs="$noconfigdirs emacs emacs19 target-libgloss"
487 ;;
488 # start-sanitize-m32r
489 m32r-*-*)
490 noconfigdirs="$noconfigdirs target-libio target-libstdc++ target-libg++ gdb"
491 ;;
492 # end-sanitize-m32r
493 mn10200-*-*)
494 noconfigdirs="$noconfigdirs ld gcc gdb target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
495 ;;
496 mn10300-*-*)
497 noconfigdirs="$noconfigdirs gdb target-libgloss"
498 ;;
499 powerpc-*-aix*)
500 # copied from rs6000-*-* entry
501 noconfigdirs="$noconfigdirs gprof cvs target-libgloss"
502 # This is needed until gcc and ld are fixed to work together.
503 use_gnu_ld=no
504 ;;
505 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
506 target_configdirs="$target_configdirs target-winsup"
507 noconfigdirs="$noconfigdirs gdb tcl tk make expect target-libgloss"
508 # always build newlib.
509 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
510 ;;
511 # This is temporary until we can link against shared libraries
512 powerpcle-*-solaris*)
513 noconfigdirs="$noconfigdirs gdb sim make tcl tk expect"
514 ;;
515 rs6000-*-lynxos*)
516 # The CVS server code doesn't work on the RS/6000
517 # Newlib makes problems for libg++ in crosses.
518 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
519 ;;
520 rs6000-*-aix*)
521 noconfigdirs="$noconfigdirs gprof"
522 # This is needed until gcc and ld are fixed to work together.
523 use_gnu_ld=no
524 ;;
525 rs6000-*-*)
526 noconfigdirs="$noconfigdirs gprof"
527 ;;
528 m68k-apollo-*)
529 noconfigdirs="$noconfigdirs ld binutils gprof target-libgloss"
530 ;;
531 mips*-*-irix5*)
532 # The GNU linker does not support shared libraries.
533 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
534 noconfigdirs="$noconfigdirs ld gprof emacs target-libgloss"
535 ;;
536 mips*-*-irix6*)
537 # The GNU linker does not support shared libraries.
538 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
539 # BFD does not have Irix 6 support yet.
540 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes gdb readline mmalloc sim gprof emacs target-libgloss"
541 ;;
542 mips*-dec-bsd*)
543 noconfigdirs="$noconfigdirs gprof target-libgloss"
544 ;;
545 mips*-*-bsd*)
546 noconfigdirs="$noconfigdirs gprof target-libgloss"
547 ;;
548 mips*-*-*)
549 noconfigdirs="$noconfigdirs gprof"
550 ;;
551 romp-*-*)
552 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes target-libgloss"
553 ;;
554 sh-*-*)
555 case "${host}" in
556 i[3456]86-*-vsta) ;; # don't add gprof back in
557 i[3456]86-*-go32) ;; # don't add gprof back in
558 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
559 esac
560 noconfigdirs="$noconfigdirs target-libgloss"
561 ;;
562 sparc-*-sunos4*)
563 if [ x${is_cross_compiler} != xno ] ; then
564 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib target-libgloss"
565 else
566 use_gnu_ld=no
567 fi
568 ;;
569 v810-*-*)
570 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes target-libgloss"
571 ;;
572 # start-sanitize-v850
573 v850-*-*)
574 noconfigdirs="$noconfigdirs target-libgloss"
575 ;;
576 # end-sanitize-v850
577 vax-*-vms)
578 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes target-libgloss"
579 ;;
580 vax-*-*)
581 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
582 ;;
583 *-*-lynxos*)
584 # Newlib makes problems for libg++ in crosses.
585 noconfigdirs="$noconfigdirs target-newlib target-libgloss"
586 ;;
587 *-*-macos* | \
588 *-*-mpw*)
589 # Macs want a resource compiler.
590 configdirs="$configdirs grez"
591 ;;
592 esac
593
594 # targets that need a second pass
595 case "${target}" in
596 *-gm-magic*)
597 noconfigdirs="$noconfigdirs target-libgloss"
598 ;;
599 esac
600
601 # If we aren't building newlib, then don't build libgloss, since libgloss
602 # depends upon some newlib header files.
603 case "${noconfigdirs}" in
604 *target-libgloss*) ;;
605 *target-newlib*) noconfigdirs="$noconfigdirs target-libgloss" ;;
606 esac
607
608 # If we are building a Canadian Cross, discard tools that can not be built
609 # using a cross compiler. FIXME: These tools should be fixed.
610 if [ "${build}" != "${host}" ]; then
611 noconfigdirs="$noconfigdirs tcl tk expect dejagnu"
612 fi
613
614 # Make sure we don't let GNU ld be added if we didn't want it.
615 if [ x$with_gnu_ld = xno ]; then
616 use_gnu_ld=no
617 noconfigdirs="$noconfigdirs ld"
618 fi
619
620 # Make sure we don't let GNU as be added if we didn't want it.
621 if [ x$with_gnu_as = xno ]; then
622 use_gnu_as=no
623 noconfigdirs="$noconfigdirs gas"
624 fi
625
626 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
627 # $target_configdirs.
628 # If we have the source for $noconfigdirs entries, add them to $notsupp.
629
630 notsupp=""
631 for dir in . $skipdirs $noconfigdirs ; do
632 dirname=`echo $dir | sed -e s/target-//g`
633 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
634 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
635 if [ -r $srcdir/$dirname/configure ] \
636 || [ -r $srcdir/$dirname/configure.in ]; then
637 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
638 true
639 else
640 notsupp="$notsupp $dir"
641 fi
642 fi
643 fi
644 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
645 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
646 if [ -r $srcdir/$dirname/configure ] \
647 || [ -r $srcdir/$dirname/configure.in ]; then
648 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
649 true
650 else
651 notsupp="$notsupp $dir"
652 fi
653 fi
654 fi
655 done
656
657 # Sometimes the tools are distributed with libiberty but with no other
658 # libraries. In that case, we don't want to build target-libiberty.
659 if [ -n "${target_configdirs}" ]; then
660 others=
661 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
662 if [ "$i" != "libiberty" ]; then
663 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
664 others=yes;
665 break;
666 fi
667 fi
668 done
669 if [ -z "${others}" ]; then
670 target_configdirs=
671 fi
672 fi
673
674 # Deconfigure all subdirectories, in case we are changing the
675 # configuration from one where a subdirectory is supported to one where it
676 # is not.
677 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
678 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
679 rm -f $i/Makefile
680 done
681 fi
682 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
683 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
684 rm -f ${target_subdir}/$i/Makefile
685 done
686 fi
687
688 # Produce a warning message for the subdirs we can't configure.
689 # This isn't especially interesting in the Cygnus tree, but in the individual
690 # FSF releases, it's important to let people know when their machine isn't
691 # supported by the one or two programs in a package.
692
693 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
694 # If $appdirs is non-empty, at least one of those directories must still
695 # be configured, or we error out. (E.g., if the gas release supports a
696 # specified target in some subdirs but not the gas subdir, we shouldn't
697 # pretend that all is well.)
698 if [ -n "$appdirs" ]; then
699 for dir in $appdirs ; do
700 if [ -r $dir/Makefile.in ]; then
701 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
702 appdirs=""
703 break
704 fi
705 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
706 appdirs=""
707 break
708 fi
709 fi
710 done
711 if [ -n "$appdirs" ]; then
712 echo "*** This configuration is not supported by this package." 1>&2
713 exit 1
714 fi
715 fi
716 # Okay, some application will build, or we don't care to check. Still
717 # notify of subdirs not getting built.
718 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
719 echo " ${notsupp}" 1>&2
720 echo " (Any other directories should still work fine.)" 1>&2
721 fi
722
723 # Set with_gnu_as and with_gnu_ld as appropriate.
724 #
725 # This is done by determining whether or not the appropriate directory
726 # is available, and by checking whether or not specific configurations
727 # have requested that this magic not happen.
728 #
729 # The command line options always override the explicit settings in
730 # configure.in, and the settings in configure.in override this magic.
731 #
732 # If the default for a toolchain is to use GNU as and ld, and you don't
733 # want to do that, then you should use the --without-gnu-as and
734 # --without-gnu-ld options for the configure script.
735
736 if [ x${use_gnu_as} = x ] ; then
737 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
738 with_gnu_as=yes
739 withoptions="$withoptions --with-gnu-as"
740 fi
741 fi
742
743 if [ x${use_gnu_ld} = x ] ; then
744 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
745 with_gnu_ld=yes
746 withoptions="$withoptions --with-gnu-ld"
747 fi
748 fi
749
750 # If using newlib, add --with-newlib to the withoptions so that gcc/configure
751 # can detect this case.
752
753 if [ x${with_newlib} != xno ] && echo " ${target_configdirs} " | grep " target-newlib " > /dev/null 2>&1 && [ -d ${srcdir}/newlib ] ; then
754 with_newlib=yes
755 withoptions="$withoptions --with-newlib"
756 fi
757
758 if [ x${shared} = xyes ]; then
759 case "${target}" in
760 hppa*) target_makefile_frag=config/mt-papic ;;
761 i[3456]86-*) target_makefile_frag=config/mt-x86pic ;;
762 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
763 esac
764 fi
765
766 # post-target:
767
768 # Make sure that the compiler is able to generate an executable. If it
769 # can't, we are probably in trouble. We don't care whether we can run the
770 # executable--we might be using a cross compiler--we only care whether it
771 # can be created. At this point the main configure script has set CC.
772 echo "int main () { return 0; }" > conftest.c
773 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
774 if [ $? = 0 ] && [ -s conftest ]; then
775 :
776 else
777 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
778 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
779 rm -f conftest*
780 exit 1
781 fi
782 rm -f conftest*
783
784 # The Solaris /usr/ucb/cc compiler does not appear to work.
785 case "${host}" in
786 sparc-sun-solaris2*)
787 CCBASE="`echo ${CC-cc} | sed 's/ .*$//'`"
788 if [ "`/usr/bin/which $CCBASE`" = "/usr/ucb/cc" ] ; then
789 could_use=
790 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
791 if [ -d /opt/cygnus/bin ] ; then
792 if [ "$could_use" = "" ] ; then
793 could_use="/opt/cygnus/bin"
794 else
795 could_use="$could_use or /opt/cygnus/bin"
796 fi
797 fi
798 if [ "$could_use" = "" ] ; then
799 echo "Warning: compilation may fail because you're using"
800 echo "/usr/ucb/cc. You should change your PATH or CC "
801 echo "variable and rerun configure."
802 else
803 echo "Warning: compilation may fail because you're using"
804 echo "/usr/ucb/cc, when you should use the C compiler from"
805 echo "$could_use. You should change your"
806 echo "PATH or CC variable and rerun configure."
807 fi
808 fi
809 ;;
810 esac
811
812 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
813 # binutils tools will find libbfd.so.
814 if [ "${shared}" = "yes" ]; then
815 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
816 Makefile > Makefile.tem
817 rm -f Makefile
818 mv -f Makefile.tem Makefile
819
820 case "${host}" in
821 *-*-hpux*)
822 sed -e 's/RPATH_ENVVAR[ ]*=.*$/RPATH_ENVVAR = SHLIB_PATH/' \
823 Makefile > Makefile.tem
824 rm -f Makefile
825 mv -f Makefile.tem Makefile
826 ;;
827 esac
828 fi
829
830 # Record target_configdirs and the configure arguments in Makefile.
831 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
832 targargs=`echo "${arguments}" | \
833 sed -e 's/--norecursion//' \
834 -e 's/--cache[a-z-]*=[^ ]*//' \
835 -e 's/--ho[a-z-]*=[^ ]*//' \
836 -e 's/--ta[a-z-]*=[^ ]*//'`
837
838 # Passing a --with-cross-host argument lets the target libraries know
839 # whether they are being built with a cross-compiler or being built
840 # native. However, it would be better to use other mechanisms to make the
841 # sorts of decisions they want to make on this basis. Please consider
842 # this option to be deprecated. FIXME.
843 if [ x${is_cross_compiler} = xyes ]; then
844 targargs="--with-cross-host=${host_alias} ${targargs}"
845 fi
846
847 targargs="--host=${target_alias} ${targargs}"
848 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
849 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
850 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
851 Makefile > Makefile.tem
852 rm -f Makefile
853 mv -f Makefile.tem Makefile
854
855 #
856 # Local Variables:
857 # fill-column: 131
858 # End:
859 #
This page took 0.066074 seconds and 5 git commands to generate.